/*
 *  Similar to dashboard/model.js but provides caching
 */
import Ajaxqueue from 'ajax_queue'

var widgets = {}    // promises
var dashboards = {} // promises

var Tabs = {

	_call: function(url, data, done) {
		done = done || function(){};
		return new Promise(function(resolve){
			if(__DEV__ && !url){ // TODO do this using ajaxQueue.logErrors ?
				done({error: 'missing url'});
				resolve({error: 'missing url'});
			}else{
				Ajaxqueue({
					url      : '/backend/' + url + '/',
					json     : data,
					priority : 'very-high',
					success  : function(result) {
						done(result);
						resolve(result);
					},
					logErrors: url, //TODO: give a sensible message
					error    : function(result) {
						console.warn('Tabs.' + url + ': ', result);
						if(result.error){
							for(var i in result.error) console.log(result.error[i]);
							done(result);
							resolve({error: result});
						}
					}
				})
			}
		})
	},

	load: new Promise(function(resolve) {
		Ajaxqueue({
			url: '/backend/get-dashboard-set/',
			priority: 'vip',
			complete: resolve
		})
	}),

	add_dashboard: function(set_name, done) {
		console.log('Tabs.add_dashboard');
		Tabs._call('add-dashboard', {set: set_name}, done);
	},

	remove_dashboard: function(name, done) {
		console.log('Tabs.remove_dashboard: ' + name);
		Tabs._call('remove-dashboard', {name: name}, done);
	},

	get: function(name) {
		//return Tabs._call('/backend/get-dashboard/', {name: name});
		return dashboards[name] || (dashboards[name] = Tabs._call('get-dashboard', {name: name}))
	},

	save_dashboard: function(data, done) {
		console.log('save_dashboard: ' + data.title);
		Tabs._call('save-dashboard', data, done);
	},

	save_dashboard_set: function(data, done) {
		console.log('Tabs.save_dashboard_set');
		Tabs._call('save-dashboard-set', data, done);
	},

	Widget: {
		add: function(dashboard, widget, done) {
			console.log('Tabs.add_widget', widget);
			widget.dashboard = dashboard;
			Tabs._call('add-widget', widget, done);
		},

		remove: function(name, done) {
			console.log('Tabs.remove_widget: ' + name);
			Tabs._call('remove-widget', {name: name}, done);
		},

		move: function(widget_name, src, dest, done) {
			console.log('Tabs.move_widget: ' + widget_name, '. ', src + ' --> ' + dest);
			if(src !== dest){
				Tabs._call('move-widget', {widget: widget_name, src: src, dest: dest}, function(result){
					done(result);
				});
			}else{
				console.warn('ignoring request to move to same dashboard.');
			}
		},

		save: function(data, done) {
			console.log('Tabs.Widget.save: ' + data.name);
			Tabs._call('save-widget', data, done);
		},

		get: function(name) {
			return widgets[name] || (widgets[name] =
				Tabs._call('get-widget', {name: name}))
					.then(function(result){
						if(__DEV__ && Tabs.widgets[name]) console.warn('already set')
						return Tabs.widgets[name] = result
					})
		}
	},

	widgets: {} // object cache - use if you need to access synchronously
}

export default Tabs;

