import $ from 'jquery'
import Dialogue from 'dialogue'
import User from 'user_info'
import h from 'virtual-dom/h'
import RenderTree from 'render-tree'
import './need_login.css'

User.info.then(function(user) {
	document.querySelector('#main').appendChild(document.createElement('h1')).innerText = 'ecCharts'

	var el = document.querySelector('body').appendChild(document.createElement('div'))
	var width = 480

	var vdom = new RenderTree({
		main: {
			render: function(){
				var body = h('.modal-body', [
					h('p', 'EcCharts is available to forecasters only.'),
					user.user_name ? undefined : h('p', 'If you have access please log in to proceed')
				])
				return dialogue.render(body)
			}
		},
		root: el
	})

	// TODO change layout method so that footer is always at bottom of dialogue
	vdom.on.render.once(function(){
		var element = $(el)
		element.find('.modal-body').css({height: 200 - element.find('.modal-header').outerHeight(true) - element.find('.modal-footer').outerHeight(true)})
	})

	var dialogue = new Dialogue({
		id: 'login-warning',
		renderer: vdom,
		title: (user.user_name ? 'Access' : 'You are not logged in'),
		size: {width: width, height: 200},
		position: {top: 100, left: $(window).width() / 2 - width / 2},
		footer: function() {
			if(!user.user_name)
				return [h('input.ui-button.ui-button-text.primary', {
					type: 'submit',
					value: 'Login',
					style: {float: 'right'},
					onclick: function() {
						var host = window.ECMWF.options.apps_frontend_host
						location.href = (host ? '//' + host : '') + '/auth/login/?back=' + encodeURIComponent(location.href)
					}
				})]
		}
	})

	vdom.render()
})
