	//TODO add thumbnail example - see layerList

	jQuery(document).ready(function($){

		var default_submit_handler = function(result){
			el.p('Form submitted');
			el.div().html('<pre>' + dump({result: result}) + '</pre>');
		}
		var submit_handler = default_submit_handler;

		var el = $('#mainColumn');

		var output = el.div();

		// form demo
		// ---------

		var layer_styles = ["grid_10x20_tan", "grid_10x20_blue", "grid_1x1_tan", "grid_5x5_tan"];
		var styles = [];
		for(var i in layer_styles){
			var style = layer_styles[i];
			var url = ECMWF.options.ajax.backend.get_style_thumbnail;
			url = url.replace("NAME", style);
			styles[style] = {
				title : style,
				url   : url,
				XXXfetch_image: function(){}
			};
		}

		el.div({css: {marginTop: 10}})
			.form({
				title : "Form Title",
				items: [
					{ type: "text",    name: "text",        value: "multi\nline", help: "Enter your comments in the box on the left." , title: "Comment"},
					{ type: "string",  name: "string",      value: "foo" },
					{ type: "integer", name: "integer",     value: 42,  range : [-100,100] },
					{ type: "float",   name: "float",       value: 3.14,  range : [1,10] },
					{ type: "float",   name: "precision1",  value: 3.14,  range : [1,10], precision : 1 },
					{ type: "float",   name: "precision0",  value: 3.14,  range : [1,10], precision : 0 },
					{ type: "float",   name: "precision-1", value: 12.345,  precision : -1 },
					{
						type : "float",  name: "temperature", value: 273.15, 
						title : "Temperature",
						range : [0,400],
						unit  : "&deg;C",
						transform : { ui2value : function(x) { return x + 273.15; }, 
							value2ui : function(x) { return x - 273.15; }
						}
					},
					{
						type : "choice", name: "choice", value: "bar", values : ["foo", "bar", "baz"], 
						labels : { foo : "Le Foo", bar : "Das Bar", baz : "El Baz" }
					},
					{ type : "choice", name: "choice-multiple",      value: "baz", values : ["foo", "bar", "baz"] ,  multiple: true },
					{ type : "choice", name: "choice-menu",          value: "bar", values : ["foo", "bar", "baz"] ,  menu : true },
					{ type : "choice", name: "choice-menu-multiple", value: ["foo", "baz"], values : ["foo", "bar", "baz"] ,  menu : true, multiple: true },
					{
						type : "choice", name: "operator", value: "<=", values : ["=", "<>", ">", "<", "<=", ">="] ,  
						labels : {
							"=" : "equal", "<>" : "different", ">" : "greater than", "<" : "less than", 
							"<=" : "less or equal", ">=" : "greater or equal"},
						menu : true
					},
					{
						type : "choice", name: "icon-multiple", value: "probability_blue", 
						values : ["probability_blue", "proba_green", "proba_red"] ,  
						multiple: true,
						labels : function(name) {
							var href = "{% url 'backend:get-contour-thumbnail' 'NAME' %}";
							href = href.replace("NAME",name);
							return "<img src='" + href + "'>";
						}
					},

					{ type : "choice", name: "icon", value: "proba_red", 
						values : ["probability_blue", "proba_green", "proba_red"] ,  
						multiple: false,
						labels : function(name) {
							var href = "{% url 'backend:get-contour-thumbnail' 'NAME' %}";
							href = href.replace("NAME",name);
							return "<img src='" + href + "'>";
						}
					},

					{ type : "point",   name: "point",    value: {lat: -50, lon: -9 }},
					{ type : "colour",  name: "colour 1", value: 'red' },
					{ type : "colour",  name: "colour 2", value: "green" },
					{ type : "colour",  name: "colour 3", value: "blue" },
					{ type : "boolean", name: "true",     value: true},
					{ type : "boolean", name: "false",    value: false},

					{ type : "point", name: "point-range-lat",  value: {lat: 0, lon: -9 }, range : { lat : [-10,10] } },
					{ type : "point", name: "point-range-lon",  value: {lat: 0, lon: -9 }, range : { lon : [-10,10] } },
					{ type : "point", name: "point-range-both", value: {lat: 0, lon: -9 }, range : { lat : [-10,10], lon : [-10,10] } },

					{
						type  : "thumbnail",
						name  : "style",
						title : "Style",
						value : layer_styles[0],
						values: layer_styles,
						labels: styles
					},

					//colour fields using different format:
					{ type: 'colour', title: 'Colour field 1', name: 'colour_1'},
					{ type: 'colour', title: 'Colour field 2', name: 'colour_2'}

/* FIXME currently not testable as is private to dashboard widget.
					{ type: 'objectlist', subtype: 'product', title: 'Catalogue', name: 'catalogue_1'}
*/
				],

				//global values?
				values: {
					colour_1: 'red',
					colour_2: 'blue'
				},

				show_cancel: false,
				ok: function(result){ submit_handler(result); }
			});

			function dump(obj, indent) { 
				var result = "";
				indent = indent || '';

				for (var property in obj)
				{
					var value = obj[property];
					if (typeof value == 'string')
						value = '"' + value + '"';
					else if (typeof value == 'object')
					{
						if (value instanceof Array) { 
							value = "[ " + value + " ]"; 
						}
						else 
						{ 
							var od = dump(value, indent + "  "); 
							value = "\n" + indent + " {\n" + od + "\n" + indent + " }"; 
						} 
					} 
					result += indent + '"' + property + '" : ' + value + ",\n"; 
				}
				return result.replace(/,\n$/, "");
			}

		// dynamic tests:
		// --------------

		function test_zero_float_value(){

			// with value passed via the items array:
			var f1 = el.div()
				.form({
					items: [
						{ type: 'float', name: 'float', value: 3.14 }
					]
				});
			if(f1.find('input').val() !== '3.14') return false;
			f1.remove();

			// with value passed via the values array:
			f1 = el.div()
				.form({
					items: [
						{ type: 'float', name: 'float' }
					],
					values: {'float': 3.14}
				});
			if(f1.find('input').val() !== '3.14') return false;
			f1.remove();

			// with zero value passed via the values array:
			f1 = el.div()
				.form({
					items: [
						{ type: 'float', name: 'float' }
					],
					values: {'float': 0}
				});
			if(f1.find('input').val() !== '0') return false;
			f1.remove();

			return true;
		}

		function test_default_values(){
			submit_handler = function(result){
				if(result.string !== 'foo') console.log('error! string');
				if(result.choice !== 'bar') console.log('error! choice');
			}
			$('#_ok').click(function(){
				submit_handler = default_submit_handler;
				return false;
			}).click();

			return true;
		}

		output.text('running tests ...');
		var f1 = test_zero_float_value();
		var f2 = test_default_values();
		output.text('tests complete. pass=' + f1 + ', ' + f2);
	});


