import ECMWF from 'config'
import $ from 'jquery'
import extend from 'extend'
import Utils from 'utils'

$.fn.orelse = function(fn){

	// execute the fn only if no elements are selected.
	// -can be used to create an element if it doesn't already exist.
	// -fn can change the chain by optionally returning a value.
	// -if fn is not a function, it is returned directly (can be used to provide an alternative dom selector if the original one is empty).

	var ret;
	return $(this).length
		? $(this)
		: typeof fn !== 'function'
			? fn
			: ((ret = fn())
				? ret
				: $(this));
}

$.fn.ensure = function(sel){
	// if the named child div exists, return it, otherwise create it first

	var self = this;
	return $(this).find('> ' + sel).orelse(function(){ return $(self).div(sel); });
}

$.fn.delayed = function(delay, fn){

	//wrapper for $.fn.queue() that delays execution, and continues execution of the queue.

	return this.delay(delay).queue(function(next){
		fn.apply(this);
		next();
	});
}

$.fn.clear = function(){

	// adds a br to clear floats.

	return $(this).br('.br-clear');
}

$.fn.pack = function(items){

	// add the given items as children of the node.

	var self = $(this);
	$(arguments).each(function(i, o){ o.appendTo(self); });
};


$.pluck = function(obj, key){

	// given an array of objects, returns an array of values for the given property name

	return $.map(obj, function(value){ return value[key]; });
}

/*
 *   jquery deprecated fn
 */
$.isWindow = function (obj) {
	return obj != null && obj === obj.window;
}

/*
 *  ECMWF.map provides the ability to apply mappings to simple objects
 *  similar to $.map but returns an object instead of an array.
 *  It preserves the original keys so cannot be used to convert an array to an object.
 */
Utils.map = function(object, f, ctx){
	ctx = ctx || this;
	var result = {};
	$.each(Object.keys(object), function(i, v) {
		var val = f.call(ctx, object[v], v, object);
		(typeof val !== 'undefined' && val !== null) && (result[v] = val);
	});
	return result;
}
if(!Object.keys){
	Utils.map = function(object, fn, ctx) {
		var result = {};
		$.each(object, function(i, v) {
			if(typeof v !== 'undefined' && object.hasOwnProperty(i)){
				var val = fn(v);
				(typeof val !== 'undefined' && val !== null) && (result[i] = val);
			}
		});
		return result;
	}
}

